package okay.collections;

/**
 * Represents one dictionary entry.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
class DictionaryNode<T> {

    private String key;
    private T element;
    private DictionaryNode next = null;

    DictionaryNode(String key, T element) {
        this.key = key;
        this.element = element;
    }

    T getElement() {
        return element;
    }

    void setElement(T element) {
        this.element = element;
    }

    DictionaryNode getNext() {
        return next;
    }

    void setNext(DictionaryNode next) {
        this.next = next;
    }

    String getKey() {
        return key;
    }

    void setKey(String key) {
        this.key = key;
    }

}
