package okay.database;

import okay.collections.Queue;

/**
 * Used to execute more sql commands at once to achieve better performance.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class SqlCommandQueue {

    private final Queue<String> queue = new Queue<>();

    /**
     * Adds sql command.
     *
     * @param command
     */
    public void add(String command) {
        this.queue.enqueue(command);
    }

    String loadNextCommand() {
        return this.queue.dequeue();
    }

    boolean isThereANextCommand() {
        return !this.queue.isEmpty();
    }

    @Override
    public String toString() {
        return this.queue.toString();
    }

}
