package okay.json;

/**
 * Used to store char and String constants used to parse or print json objects
 * or arrays.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
class JsonSpecialCharSequences {

    private static final char OBJECTLEFT = '{';
    private static final char OBJECTRIGHT = '}';
    private static final char ARRAYLEFT = '[';
    private static final char ARRAYRIGHT = ']';
    private static final char COMMA = ',';
    private static final char COLON = ':';
    private static final char APOSTROPHE = '"';
    private static final String LINEBREAK = "\n";
    private static final String NULL = "null";
    private static final String TRUE = "true";
    private static final String FALSE = "false";
    private static final String TAB = "   ";
    private static final char SPACE = ' ';

    private JsonSpecialCharSequences() {
    }

    static char getObjectLeft() {
        return OBJECTLEFT;
    }

    static char getObjectRight() {
        return OBJECTRIGHT;
    }

    static char getArrayLeft() {
        return ARRAYLEFT;
    }

    static char getArrayRight() {
        return ARRAYRIGHT;
    }

    static char getComma() {
        return COMMA;
    }

    static char getColon() {
        return COLON;
    }

    static char getApostrophe() {
        return APOSTROPHE;
    }

    static String getLineBreak() {
        return LINEBREAK;
    }

    static String getNull() {
        return NULL;
    }

    static String getTrue() {
        return TRUE;
    }

    static String getFalse() {
        return FALSE;
    }

    static String getTab() {
        return TAB;
    }

    static char getSpace() {
        return SPACE;
    }
}
