package okay.pseudorandom;

/**
 * Represents seed. Uses linear congruential function.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
class Seed {

    private long currentSeed;
    private static final int A = 16807;
    private static final int C = 0;
    private static final long M = 2147483647;

    Seed(long seed) {
        this.currentSeed = seed;
    }

    long getNextNumber() {
        long number = ((A * currentSeed) + C) % M;
        this.currentSeed = number;
        return number;
    }

    void jump() {
        getNextNumber();
    }
}
