package okay.simplicity.boxes;

import okay.simplicity.Simplicity;
import okay.simplicity.window.controls.Button;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.scene.transform.Rotate;

/**
 * Represents a alert box- a window used to alarm user.
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class AlertBox extends Box {

    private AlertBox(String titleText, String text) {
        super(titleText, text);
    }

    /**
     *
     * @param windowColourSkin
     * @param titleText
     * @param text
     */
    public static void showBox(String titleText, String text) {
        AlertBox alertBox = new AlertBox(titleText, text);
        alertBox.showAndWait();
    }

    void init() {
        circle.setFill(Color.rgb(237, 103, 103));
        Rectangle rectangle1 = new Rectangle(2 * Simplicity.getDpmm(), 8 * Simplicity.getDpmm());
        Rectangle rectangle2 = new Rectangle(2 * Simplicity.getDpmm(), 8 * Simplicity.getDpmm());
        Rotate rotate45 = new Rotate(45, 1.0 * Simplicity.getDpmm(), 4.0 * Simplicity.getDpmm());
        Rotate rotateMinus45 = new Rotate(-45, 1.0 * Simplicity.getDpmm(), 4.0 * Simplicity.getDpmm());
        rectangle1.getTransforms().addAll(rotate45);
        rectangle2.getTransforms().addAll(rotateMinus45);
        this.icon.getChildren().addAll(rectangle1, rectangle2);

        rectangle1.setFill(Color.rgb(238, 238, 238));
        rectangle2.setFill(Color.rgb(238, 238, 238));

        Button okButton = new Button("OK");

        this.placeForButtons.getChildren().add(okButton);
        okButton.setMaxWidth(20 * Simplicity.getDpmm());
        okButton.setOnAction(this::handleOKButtonAction);
    }
}
