package okay.simplicity.boxes;

import okay.simplicity.Simplicity;
import okay.simplicity.window.controls.Button;
import javafx.geometry.Pos;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;

/**
 * Represents a message box- a window used to inform user about something.
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class MessageBox extends Box {

    private MessageBox(String titleText, String text) {
        super(titleText, text);
    }

    /**
     *
     * @param windowColourSkin
     * @param titleText
     * @param text
     */
    public static void showBox(String titleText, String text) {
        MessageBox messageBox = new MessageBox(titleText, text);
        messageBox.showAndWait();
    }

    void init() {
        circle.setFill(Color.rgb(114, 159, 207));
        Rectangle rectangle1 = new Rectangle(2 * Simplicity.getDpmm(), 5 * Simplicity.getDpmm());
        Rectangle rectangle2 = new Rectangle(2 * Simplicity.getDpmm(), 2 * Simplicity.getDpmm());
        this.icon2.getChildren().addAll(rectangle1, rectangle2);
        this.icon.getChildren().add(icon2);

        this.icon2.setAlignment(rectangle1, Pos.BOTTOM_CENTER);
        this.icon2.setAlignment(rectangle2, Pos.TOP_CENTER);
        this.icon2.setMaxHeight(8 * Simplicity.getDpmm());
        rectangle1.setFill(Color.rgb(238, 238, 238));

        rectangle2.setFill(Color.rgb(238, 238, 238));
        Button okButton = new Button("OK");

        this.placeForButtons.getChildren().add(okButton);
        okButton.setMaxWidth(20 * Simplicity.getDpmm());
        okButton.setOnAction(this::handleOKButtonAction);
    }
}
