package okay.simplicity.window;

import okay.simplicity.Simplicity;
import javafx.geometry.Insets;
import javafx.geometry.VPos;
import javafx.scene.Node;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.RowConstraints;

/**
 * Represents a layout.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class SLayout extends GridPane {

    private final RowConstraints dataRowConstraint = new RowConstraints();

    /**
     * Constructor
     */
    public SLayout() {
        this.setSpacing(true);

        dataRowConstraint.setMinHeight(6 * Simplicity.getDpmm());
        dataRowConstraint.setMaxHeight(6 * Simplicity.getDpmm());
        dataRowConstraint.setValignment(VPos.CENTER);
    }

    /**
     *
     * @param value
     */
    public void setSpacing(boolean value) {
        if (value) {
            this.setVgap(3 * Simplicity.getDpmm());
            this.setHgap(3 * Simplicity.getDpmm());
            this.setPadding(new Insets(3 * Simplicity.getDpmm()));
        } else {
            this.setVgap(0);
            this.setHgap(0);
            this.setPadding(Insets.EMPTY);
        }
    }

    /**
     *
     * @return
     */
    public RowConstraints getDataRowConstraint() {
        return this.dataRowConstraint;
    }

    /**
     *
     * @param gridPane
     * @param col
     * @param row
     * @return
     */
    public Node getNodeFromGridPane(GridPane gridPane, int col, int row) {
        for (Node node : gridPane.getChildren()) {
            if (GridPane.getColumnIndex(node) == col && GridPane.getRowIndex(node) == row) {
                return node;
            }
        }
        return null;
    }
}
