package okay.simplicity.window;

import okay.simplicity.Simplicity;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.StackPane;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class TitleIcon extends StackPane {

    /**
     * Title bar icon image.
     */
    private final ImageView imageView = new ImageView();
    private static final double TITLEICONHEIGHT = 4.5;

    /**
     * Constructor
     *
     * @param windowColourSkin
     */
    TitleIcon() {
        setStyle("-fx-background-color: rgb(" + Simplicity.getDefaultWindowColourSkin().getRGBStringForCSS(ColourVariant.DARK) + ");");
        imageView.setFitWidth(Simplicity.getDpmm() * TITLEICONHEIGHT);
        imageView.setFitHeight(Simplicity.getDpmm() * TITLEICONHEIGHT);
        imageView.setPreserveRatio(true);
        imageView.setSmooth(true);
        imageView.setCache(true);
        getChildren().add(imageView);
    }

    /**
     *
     * @param path
     */
    public void setIcon(String path) {
        Image image = new Image(path);
        imageView.setImage(image);
    }
}
