package okay.simplicity.window;

/**
 * Window size modes.
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public enum WindowSizeMode {

    /**
     * Window is not fullscreen. Window is not maximized. Window has borders and
     * we can move it and change its size. Window has decorations.
     */
    RESTORED,
    /**
     * Window has no borders, we cannot move it. We cannot resize it. Window has
     * decorations.
     */
    MAXIMIZED,
    /**
     * Window has no borders, we cannot move it. We cannot resize it. Window has
     * no decorations.
     */
    FULLSCREEN;
}
