package okay.simplicity.window.controls;

import okay.simplicity.Simplicity;
import okay.simplicity.window.ColourVariant;
import javafx.geometry.Insets;
import javafx.scene.input.MouseEvent;
import javafx.scene.text.Font;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class Button extends javafx.scene.control.Button {

    private String setStyleStartString
            = new StringBuilder("-fx-border-insets:0;-fx-background-insets:0;-fx-background-radius:0;-fx-background-color: rgb(")
                    .append(Simplicity.getDefaultWindowColourSkin().getRGBStringForCSS(ColourVariant.DARK))
                    .append(");-fx-border-color:rgb(")
                    .toString();
    private String setStyleEndString = new StringBuilder(");-fx-border-width: ")
            .append(Simplicity.getDpmm() / 2)
            .append(";")
            .toString();

    /**
     *
     * @param windowColourSkin
     * @param text
     */
    public Button(String text) {
        super(text);
        this.setMaxWidth(Double.MAX_VALUE);
        this.setMaxHeight(6 * Simplicity.getDpmm());
        this.setPadding(new Insets(0, 0, 0, 0));
        this.setFont(Font.font(3 * Simplicity.getDpmm()));
        this.setStyle(getSetStyleString("186, 186, 186"));
        setOnMouseEntered(this::handleMouseEnteredAction);
        setOnMouseExited(this::handleMouseExitedAction);
    }

    private void handleMouseEnteredAction(MouseEvent event) {//NOSONAR
        this.setStyle(getSetStyleString("0,0,0"));
    }

    private void handleMouseExitedAction(MouseEvent event) {//NOSONAR
        this.setStyle(getSetStyleString("186, 186, 186"));
    }

    private String getSetStyleString(String fxBorderColorString) {
        return new StringBuilder(setStyleStartString)
                .append(fxBorderColorString)
                .append(setStyleEndString)
                .toString();
    }
}
