package okay.simplicity.window.controls;

import javafx.scene.paint.Color;
import okay.simplicity.Simplicity;
import javafx.scene.text.Font;
import okay.simplicity.window.ColourVariant;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class SLabel extends javafx.scene.control.Label {

    /**
     * Constructor
     *
     * @param text
     */
    public SLabel(String text) {
        this(text, ColourVariant.LIGHT);
    }

    /**
     * Constructor
     *
     * @param text
     * @param colourVariant
     */
    public SLabel(String text, ColourVariant colourVariant) {
        super(text);
        setFont(Font.font(3 * Simplicity.getDpmm()));
        Color color = Simplicity.getDefaultWindowColourSkin().getColourForText(colourVariant);
        this.setTextFill(color);
    }

    /**
     * Constructor
     */
    public SLabel() {
        setFont(Font.font(3 * Simplicity.getDpmm()));
    }

}
