package okay.simplicity.window.titlebuttons;

import javafx.geometry.Pos;
import javafx.scene.shape.Line;
import okay.simplicity.Simplicity;
import okay.simplicity.window.Window;
import okay.simplicity.window.WindowColourSkin;

/**
 * Represents close button.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class CloseButton extends WindowTitleButton {

    Line line1 = new Line(0, 0, 5 * Simplicity.getDpmm(), 2.5 * Simplicity.getDpmm());
    Line line2 = new Line(0, 2.5 * Simplicity.getDpmm(), 5 * Simplicity.getDpmm(), 0);

    /**
     *
     * @param windowColourSkin
     * @param window
     */
    public CloseButton(WindowColourSkin windowColourSkin, Window window) {
        super(windowColourSkin);
        setOnMouseClicked(window::handleCloseButtonAction);
        line1.setStroke(this.windowColourSkin.getColourForInactiveWindowTitleButton());
        line1.setStrokeWidth(0.5 * Simplicity.getDpmm());
        line2.setStroke(this.windowColourSkin.getColourForInactiveWindowTitleButton());
        line2.setStrokeWidth(0.5 * Simplicity.getDpmm());
        getChildren().addAll(line1, line2);
        setAlignment(line1, Pos.CENTER);
        setAlignment(line2, Pos.CENTER);
    }

    @Override
    public void makeActive() {
        line1.setStroke(this.windowColourSkin.getColourForActiveWindowTitleCloseButton());
        line2.setStroke(this.windowColourSkin.getColourForActiveWindowTitleCloseButton());
    }

    @Override
    public void makeInactive() {
        line1.setStroke(this.windowColourSkin.getColourForInactiveWindowTitleButton());
        line2.setStroke(this.windowColourSkin.getColourForInactiveWindowTitleButton());
    }

}
