package okay.simplicity.window.titlebuttons;

import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.shape.Line;
import okay.simplicity.Simplicity;
import okay.simplicity.window.Window;
import okay.simplicity.window.WindowColourSkin;

/**
 * Represents minimize button.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class MinimizeButton extends WindowTitleButton {

    Line line1 = new Line(1 * Simplicity.getDpmm(), 3.5 * Simplicity.getDpmm(), 6 * Simplicity.getDpmm(), 3.5 * Simplicity.getDpmm());

    /**
     *
     * @param windowColourSkin
     * @param window
     */
    public MinimizeButton(WindowColourSkin windowColourSkin, Window window) {
        super(windowColourSkin);
        setOnMouseClicked(window::handleMinimizeButtonAction);
        line1.setStroke(this.windowColourSkin.getColourForInactiveWindowTitleButton());
        line1.setStrokeWidth(0.5 * Simplicity.getDpmm());
        getChildren().addAll(line1);
        setAlignment(line1, Pos.BOTTOM_CENTER);
        this.setPadding(new Insets(Simplicity.getDpmm(), Simplicity.getDpmm(), Simplicity.getDpmm(), Simplicity.getDpmm()));

    }

    @Override
    public void makeActive() {
        line1.setStroke(this.windowColourSkin.getColourForActiveWindowTitleButton());
    }

    @Override
    public void makeInactive() {
        line1.setStroke(this.windowColourSkin.getColourForInactiveWindowTitleButton());
    }
}
