/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okay.collections;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class DictionaryKeyIteratorTest {

    /**
     *
     */
    public DictionaryKeyIteratorTest() {
    }

    /**
     * Test of getNextKey method, of class DictionaryKeyIterator.
     */
    @Test
    public void testGetNextKey() {
        //arrange
        Dictionary<String> dictionary = new Dictionary<>();
        DictionaryKeyIterator dictionaryKeyIterator;
        StringBuilder stringBuilder = new StringBuilder();
        String key1;
        String key2;
        String key3;
        String value1;
        String value2;
        String value3;
        String expectedString = "JohnJohnycalm";
        String returnedString;
        //act
        dictionary.addValue("name", "John").addValue("surname", "Black").addValue("nick", "Johny");
        dictionary.removeValue("surname");
        dictionary.addValue("personality", "calm");
        dictionaryKeyIterator = dictionary.getKeyIterator();
        key1 = dictionaryKeyIterator.getNextKey();
        key2 = dictionaryKeyIterator.getNextKey();
        key3 = dictionaryKeyIterator.getNextKey();

        value1 = dictionary.getValue(key1);
        value2 = dictionary.getValue(key2);
        value3 = dictionary.getValue(key3);

        stringBuilder.append(value1);
        stringBuilder.append(value2);
        stringBuilder.append(value3);
        returnedString = stringBuilder.toString();
        //assert
        assertEquals(expectedString, returnedString);
    }

    /**
     * Test of hasNext method, of class DictionaryKeyIterator.
     */
    @Test
    public void testHasNext() {
        //arrange
        Dictionary<String> dictionary = new Dictionary<>();
        DictionaryKeyIterator dictionaryKeyIterator;
        boolean expectedValue = true;
        boolean returnedValue;
        //act
        dictionary.addValue("name", "John").addValue("surname", "Black").addValue("nick", "Johny");
        dictionary.removeValue("surname");
        dictionary.addValue("personality", "calm");
        dictionaryKeyIterator = dictionary.getKeyIterator();
        dictionaryKeyIterator.getNextKey();
        dictionaryKeyIterator.getNextKey();
        returnedValue = dictionaryKeyIterator.hasNext();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of hasNext method, of class DictionaryKeyIterator.
     */
    @Test
    public void testHasNext2() {
        //arrange
        Dictionary<String> dictionary = new Dictionary<>();
        DictionaryKeyIterator dictionaryKeyIterator;
        boolean expectedValue = false;
        boolean returnedValue;
        //act
        dictionary.addValue("name", "John").addValue("surname", "Black").addValue("nick", "Johny");
        dictionary.removeValue("surname");
        dictionary.addValue("personality", "calm");
        dictionaryKeyIterator = dictionary.getKeyIterator();
        dictionaryKeyIterator.getNextKey();
        dictionaryKeyIterator.getNextKey();
        dictionaryKeyIterator.getNextKey();
        returnedValue = dictionaryKeyIterator.hasNext();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of hasNext method, of class DictionaryKeyIterator.
     */
    @Test
    public void testHasNext3() {
        //arrange
        Dictionary<String> dictionary = new Dictionary<>();
        DictionaryKeyIterator dictionaryKeyIterator;
        boolean expectedValue = false;
        boolean returnedValue;
        //act
        dictionary.addValue("name", "John");
        dictionaryKeyIterator = dictionary.getKeyIterator();
        dictionaryKeyIterator.getNextKey();
        returnedValue = dictionaryKeyIterator.hasNext();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of hasNext method, of class DictionaryKeyIterator.
     */
    @Test
    public void testHasNext4() {
        //arrange
        Dictionary<String> dictionary = new Dictionary<>();
        DictionaryKeyIterator dictionaryKeyIterator;
        boolean expectedValue = false;
        boolean returnedValue;
        //act

        dictionaryKeyIterator = dictionary.getKeyIterator();

        returnedValue = dictionaryKeyIterator.hasNext();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of hasNext method, of class DictionaryKeyIterator.
     */
    @Test
    public void testHasNext5() {
        //arrange
        Dictionary<String> dictionary = new Dictionary<>();
        DictionaryKeyIterator dictionaryKeyIterator;
        boolean expectedValue = true;
        boolean returnedValue;
        //act
        dictionary.addValue("name", "John");
        dictionaryKeyIterator = dictionary.getKeyIterator();

        returnedValue = dictionaryKeyIterator.hasNext();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of reset method, of class DictionaryKeyIterator.
     */
    @Test
    public void testReset() {
        //arrange
        Dictionary<String> dictionary = new Dictionary<>();
        DictionaryKeyIterator dictionaryKeyIterator;
        String firstKey;

        String expectedString = "John";
        String returnedString;
        //act
        dictionary.addValue("name", "John").addValue("surname", "Black").addValue("nick", "Johny");
        dictionary.removeValue("surname");
        dictionary.addValue("personality", "calm");
        dictionaryKeyIterator = dictionary.getKeyIterator();
        for (int i = 0; i < 3; i++) {
            dictionaryKeyIterator.getNextKey();
        }
        dictionaryKeyIterator.reset();
        firstKey = dictionaryKeyIterator.getNextKey();
        returnedString = dictionary.getValue(firstKey);
        //assert
        assertEquals(expectedString, returnedString);
    }

}
