/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okay.collections;

import okay.OkayRuntimeException;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class QueueTest {

    /**
     *
     */
    public QueueTest() {
    }

    /**
     * Test of getCountOfItems method, of class Queue.
     */
    @Test
    public void testGetCountOfItems() {
        //arrange
        Queue<String> queue = new Queue<>();
        int expectedCountOfItems = 0;
        int returnedCountOfItems;
        //act
        returnedCountOfItems = queue.getCountOfItems();
        //assert
        assertEquals(expectedCountOfItems, returnedCountOfItems);
    }

    /**
     * Test of getCountOfItems method, of class Queue.
     */
    @Test
    public void testGetCountOfItems2() {
        //arrange
        Queue<String> queue = new Queue<>();
        int expectedCountOfItems = 0;
        int returnedCountOfItems;
        //act
        queue.enqueue("John");
        queue.dequeue();
        returnedCountOfItems = queue.getCountOfItems();
        //assert
        assertEquals(expectedCountOfItems, returnedCountOfItems);
    }

    /**
     * Test of getCountOfItems method, of class Queue.
     */
    @Test
    public void testGetCountOfItems3() {
        //arrange
        Queue<String> queue = new Queue<>();
        int expectedCountOfItems = 0;
        int returnedCountOfItems;
        //act
        queue.enqueue("John");
        queue.dequeue();
        queue.enqueue("Jack").enqueue("Anne").enqueue("Charlie");

        queue.dequeue();
        queue.dequeue();
        queue.dequeue();
        queue.enqueue("Jane");
        queue.dequeue();
        returnedCountOfItems = queue.getCountOfItems();
        //assert
        assertEquals(expectedCountOfItems, returnedCountOfItems);
    }

    /**
     * Test of getCountOfItems method, of class Queue.
     */
    @Test
    public void testGetCountOfItems4() {
        //arrange
        Queue<String> queue = new Queue<>();
        int expectedCountOfItems = 1;
        int returnedCountOfItems;
        //act
        queue.enqueue("John");
        queue.dequeue();
        queue.enqueue("Jack").enqueue("Anne").enqueue("Charlie");

        queue.dequeue();
        queue.dequeue();
        queue.enqueue("Jane");
        queue.dequeue();
        returnedCountOfItems = queue.getCountOfItems();
        //assert
        assertEquals(expectedCountOfItems, returnedCountOfItems);
    }

    /**
     * Test of getCountOfItems method, of class Queue.
     */
    @Test
    public void testGetCountOfItems5() {
        //arrange
        Queue<String> queue = new Queue<>();
        int expectedCountOfItems = 3;
        int returnedCountOfItems;
        //act
        queue.enqueue("John");
        queue.dequeue();
        queue.enqueue("Jack").enqueue("Anne").enqueue("Charlie").enqueue("Susan");

        queue.dequeue();
        queue.enqueue("Jane");
        queue.dequeue();
        returnedCountOfItems = queue.getCountOfItems();
        //assert
        assertEquals(expectedCountOfItems, returnedCountOfItems);
    }

    /**
     * Test of isEmpty method, of class Queue.
     */
    @Test
    public void testIsEmpty() {
        //arrange
        Queue<String> queue = new Queue<>();
        boolean expectedValue = true;
        boolean returnedValue;
        //act
        returnedValue = queue.isEmpty();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of isEmpty method, of class Queue.
     */
    @Test
    public void testIsEmpty2() {
        //arrange
        Queue<String> queue = new Queue<>();
        boolean expectedValue = true;
        boolean returnedValue;
        //act
        queue.enqueue("John").enqueue("Jack").enqueue("Anne").enqueue("Charlie");

        queue.dequeue();
        queue.dequeue();
        queue.dequeue();
        queue.dequeue();

        queue.enqueue("Jane");
        queue.dequeue();
        returnedValue = queue.isEmpty();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of isEmpty method, of class Queue.
     */
    @Test
    public void testIsEmpty3() {
        //arrange
        Queue<String> queue = new Queue<>();
        boolean expectedValue = false;
        boolean returnedValue;
        //act
        queue.enqueue("John").enqueue("Jack").enqueue("Anne").enqueue("Charlie");

        queue.dequeue();
        queue.dequeue();
        queue.dequeue();

        queue.enqueue("Jane");
        queue.dequeue();
        returnedValue = queue.isEmpty();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of isEmpty method, of class Queue.
     */
    @Test
    public void testIsEmpty4() {
        //arrange
        Queue<String> queue = new Queue<>();
        boolean expectedValue = false;
        boolean returnedValue;
        //act
        queue.enqueue("John").enqueue("Jack").enqueue("Anne").enqueue("Charlie");

        queue.dequeue();
        queue.dequeue();

        queue.enqueue("Jane");
        queue.dequeue();
        returnedValue = queue.isEmpty();
        //assert
        assertEquals(expectedValue, returnedValue);
    }

    /**
     * Test of enqueue method, of class Queue.
     */
    @Test
    public void testEnqueue() {
        //arrange
        Queue<String> queue = new Queue<>();
        String expectedString = "John";
        String returnedString;
        //act
        queue.enqueue("John");
        returnedString = queue.dequeue();
        //assert
        assertEquals(expectedString, returnedString);
    }

    /**
     * Test of dequeue method, of class Queue.
     */
    @Test
    public void testDequeue() {
        //arrange
        Queue<String> queue = new Queue<>();
        String expectedString = "Alice";
        String returnedString;
        //act
        queue.enqueue("Alice").enqueue("Jane");
        returnedString = queue.dequeue();
        //assert
        assertEquals(expectedString, returnedString);
    }

    /**
     * Test of dequeue method, of class Queue.
     */
    @Test
    public void testDequeue_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        Queue<String> queue = new Queue<>();
        //act
        try {
            queue.dequeue();
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of toString method, of class Queue.
     */
    @Test
    public void testToString() {
        //arrange
        Queue<String> queue = new Queue<>();
        String expectedString = "Alice, Jane, ";
        String returnedString;
        //act
        queue.enqueue("Alice").enqueue("Jane");
        returnedString = queue.toString();
        //assert
        assertEquals(expectedString, returnedString);
    }

}
