/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okay.database;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class SqlCommandQueueTest {

    public SqlCommandQueueTest() {
    }

    /**
     * Test of add method, of class SqlCommandQueue.
     */
    @Test
    public void testAdd() {
        //arrange
        SqlCommandQueue sqlCommandQueue = new SqlCommandQueue();
        String expectedString = "insert into customers values ('Jack','Black')";
        String returnedString;
        //act
        sqlCommandQueue.add("insert into customers values ('Jack','Black')");
        sqlCommandQueue.add("insert into customers values ('Susan','White')");
        returnedString = sqlCommandQueue.loadNextCommand();
        //assert
        assertEquals(expectedString, returnedString);
    }

    /**
     * Test of loadNextCommand method, of class SqlCommandQueue.
     */
    @Test
    public void testLoadNextCommand() {
        //arrange
        SqlCommandQueue sqlCommandQueue = new SqlCommandQueue();
        String expectedString = "insert into customers values ('Susan','White')";
        String returnedString;
        //act
        sqlCommandQueue.add("insert into customers values ('Jack','Black')");
        sqlCommandQueue.add("insert into customers values ('Susan','White')");
        sqlCommandQueue.loadNextCommand();
        returnedString = sqlCommandQueue.loadNextCommand();
        //assert
        assertEquals(expectedString, returnedString);
    }

    /**
     * Test of isThereANextCommand method, of class SqlCommandQueue.
     */
    @Test
    public void testIsThereANextCommand() {
        //arrange
        SqlCommandQueue sqlCommandQueue = new SqlCommandQueue();
        //act
        sqlCommandQueue.add("insert into customers values ('Jack','Black')");
        sqlCommandQueue.add("insert into customers values ('Susan','White')");
        sqlCommandQueue.loadNextCommand();
        //assert
        assertTrue(sqlCommandQueue.isThereANextCommand());
    }

    /**
     * Test of isThereANextCommand method, of class SqlCommandQueue.
     */
    @Test
    public void testIsThereANextCommand2() {
        //arrange
        SqlCommandQueue sqlCommandQueue = new SqlCommandQueue();
        //act
        sqlCommandQueue.add("insert into customers values ('Jack','Black')");
        sqlCommandQueue.add("insert into customers values ('Susan','White')");
        sqlCommandQueue.loadNextCommand();
        sqlCommandQueue.loadNextCommand();
        //assert
        assertFalse(sqlCommandQueue.isThereANextCommand());
    }

    /**
     * Test of toString method, of class SqlCommandQueue.
     */
    @Test
    public void testToString() {
        //arrange
        SqlCommandQueue sqlCommandQueue = new SqlCommandQueue();
        String expectedString = "insert into customers values ('Jack','Black'), insert into customers values ('Susan','White'), ";
        String returnedString;
        //act
        sqlCommandQueue.add("insert into customers values ('Jack','Black')");
        sqlCommandQueue.add("insert into customers values ('Susan','White')");
        returnedString = sqlCommandQueue.toString();
        //assert
        assertEquals(expectedString, returnedString);

    }

}
