package okay.datetime;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class DateUnitsValidatorTest {

    /**
     *
     */
    public DateUnitsValidatorTest() {
    }

    /**
     * Test of isMonthValid method, of class DateUnitsValidator.
     */
    @Test
    public void testIsMonthValid_MonthIs3_ThereShouldBeReturnedTrue() {
        //arrange
        int month = 3;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.isMonthValid(month);
        //assert
        assertTrue(returnedValue);
    }

    /**
     * Test of isMonthValid method, of class DateUnitsValidator.
     */
    @Test
    public void testIsMonthValid_MonthIs0_ThereShouldBeReturnedFalse() {
        //arrange
        int month = 0;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.isMonthValid(month);
        //assert
        assertFalse(returnedValue);
    }

    /**
     * Test of isMonthValid method, of class DateUnitsValidator.
     */
    @Test
    public void testIsMonthValid_MonthIs13_ThereShouldBeReturnedFalse() {
        //arrange
        int month = 13;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.isMonthValid(month);
        //assert
        assertFalse(returnedValue);
    }

    /**
     * Test of isDayValid method, of class DateUnitsValidator.
     */
    @Test
    public void testIsDayValid_DayIs3_ThereShouldBeReturnedTrue() {
        //arrange
        int day = 3;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.isDayValid(day);
        //assert
        assertTrue(returnedValue);
    }

    /**
     * Test of isDayValid method, of class DateUnitsValidator.
     */
    @Test
    public void testIsDayValid_DayIs0_ThereShouldBeReturnedFalse() {
        //arrange
        int day = 0;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.isDayValid(day);
        //assert
        assertFalse(returnedValue);
    }

    /**
     * Test of isDayValid method, of class DateUnitsValidator.
     */
    @Test
    public void testIsDayValid_DayIs32_ThereShouldBeReturnedFalse() {
        //arrange
        int day = 32;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.isDayValid(day);
        //assert
        assertFalse(returnedValue);
    }

    /**
     * Test of hasDateValidCombination method, of class DateUnitsValidator.
     */
    @Test
    public void testHasDateValidCombination_YearIs1992AndMonthIs3AndDayIs3_ThereShouldBeReturnedTrue() {
        //arrange
        int year = 1992;
        int month = 3;
        int day = 3;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.hasDateValidCombination(year, month, day);
        //assert
        assertTrue(returnedValue);
    }

    /**
     * Test of hasDateValidCombination method, of class DateUnitsValidator.
     */
    @Test
    public void testHasDateValidCombination_YearIs1992AndMonthIs6AndDayIs31_ThereShouldBeReturnedFalse() {
        //arrange
        int year = 1992;
        int month = 6;
        int day = 31;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.hasDateValidCombination(year, month, day);
        //assert
        assertFalse(returnedValue);
    }

    /**
     * Test of hasDateValidCombination method, of class DateUnitsValidator.
     */
    @Test
    public void testHasDateValidCombination_YearIs01992AndMonthIs2AndDayIs28_ThereShouldBeReturnedTrue() {
        //arrange
        int year = 1992;
        int month = 2;
        int day = 28;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.hasDateValidCombination(year, month, day);
        //assert
        assertTrue(returnedValue);
    }

    /**
     * Test of hasDateValidCombination method, of class DateUnitsValidator.
     */
    @Test
    public void testHasDateValidCombination_YearIs1993AndMonthIs2AndDayIs28_ThereShouldBeReturnedTrue() {
        //arrange
        int year = 1993;
        int month = 2;
        int day = 28;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.hasDateValidCombination(year, month, day);
        //assert
        assertTrue(returnedValue);
    }

    /**
     * Test of hasDateValidCombination method, of class DateUnitsValidator.
     */
    @Test
    public void testHasDateValidCombination_YearIs01993AndMonthIs2AndDayIs29_ThereShouldBeReturnedFalse() {
        //arrange
        int year = 1993;
        int month = 2;
        int day = 29;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.hasDateValidCombination(year, month, day);
        //assert
        assertFalse(returnedValue);
    }

    /**
     * Test of hasDateValidCombination method, of class DateUnitsValidator.
     */
    @Test
    public void testHasDateValidCombination_YearIs01992AndMonthIs2AndDayIs29_ThereShouldBeReturnedTrue() {
        //arrange
        int year = 1992;
        int month = 2;
        int day = 29;
        boolean returnedValue;
        //act
        returnedValue = DateUnitsValidator.hasDateValidCombination(year, month, day);
        //assert
        assertTrue(returnedValue);
    }

}
