package okay.datetime;

import okay.OkayRuntimeException;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class LocalDateTest {

    /**
     *
     */
    public LocalDateTest() {
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_ThereShouldBeThrownNoOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1994, 5, 6);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (isExceptionThrown) {
            fail("There should be thrown no OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsZero_MonthIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1994, 0, 6);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFifty_MonthIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1994, 50, 6);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_DayIsZero_DayIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1994, 5, 0);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_DayIsThirtyTwo_DayIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1994, 5, 32);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsSeptember_DayIsThirtyOne_DayIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1994, 9, 31);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsThirtyOne_YearIsNotLeap_DayIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1992, 2, 31);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsThirty_YearIsNotLeap_DayIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1993, 2, 30);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsTwentyNine_YearIsNotLeap_DayIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1993, 2, 29);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsTwentyEight_YearIsNotLeap_DayIsNotOutOfRange_ThereShouldBeThrownNoOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1993, 2, 28);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (isExceptionThrown) {
            fail("There should be thrown no OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsTwentySeven_YearIsNotLeap_DayIsNotOutOfRange_ThereShouldBeThrownNoOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1993, 2, 27);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (isExceptionThrown) {
            fail("There should be thrown no OkayRuntimeException");
        }

    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsThirtyOne_YearIsLeap_DayIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1992, 2, 31);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsThirty_YearIsLeap_DayIsOutOfRange_ThereShouldBeThrownOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1992, 2, 30);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (!isExceptionThrown) {
            fail("There should be thrown OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsTwentyNine_YearIsLeap_DayIsNotOutOfRange_ThereShouldBeThrownNoOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1992, 2, 29);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (isExceptionThrown) {
            fail("There should be thrown no OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsTwentyEight_YearIsLeap_DayIsNotOutOfRange_ThereShouldBeThrownNoOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1992, 2, 28);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (isExceptionThrown) {
            fail("There should be thrown no OkayRuntimeException");
        }
    }

    /**
     * Test of constructor of class LocalDate .
     */
    @Test
    public void testLocalDate_MonthIsFebruary_DayIsTwentySeven_YearIsLeap_DayIsNotOutOfRange_ThereShouldBeThrownNoOkayRuntimeException() {
        //arrange
        boolean isExceptionThrown = false;
        //act
        try {
            LocalDate localDate = new LocalDate(1992, 2, 27);
        } catch (OkayRuntimeException e) {
            isExceptionThrown = true;
        }
        //assert
        if (isExceptionThrown) {
            fail("There should be thrown no OkayRuntimeException");
        }
    }

    /**
     * Test of isYearLeap method, of class LocalDate.
     */
    @Test
    public void testIsYearLeap_YearIs1992_ThereShouldBeReturnedTrue() {
        //arrange
        int year = 1992;
        boolean returnedValue;
        //act
        returnedValue = LocalDate.isYearLeap(year);
        //assert
        assertTrue(returnedValue);
    }

    /**
     * Test of isYearLeap method, of class LocalDate.
     */
    @Test
    public void testIsYearLeap_YearIs1994_ThereShouldBeReturnedFalse() {
        //arrange
        int year = 1995;
        boolean returnedValue;
        //act
        returnedValue = LocalDate.isYearLeap(year);
        //assert
        assertFalse(returnedValue);
    }

    /**
     * Test of getYear method, of class LocalDate.
     */
    @Test
    public void testGetYear() {
        //arrange
        int expectedYear = 1994;
        int returnedYear;
        LocalDate localDate;
        //act
        localDate = new LocalDate(1994, 5, 6);
        returnedYear = localDate.getYear();
        //assert
        assertEquals(expectedYear, returnedYear);
    }

    /**
     * Test of getMonth method, of class LocalDate.
     */
    @Test
    public void testGetMonth() {
        //arrange
        int expectedMonth = 5;
        int returnedMonth;
        LocalDate localDate;
        //act
        localDate = new LocalDate(1994, 5, 6);
        returnedMonth = localDate.getMonth();
        //assert
        assertEquals(expectedMonth, returnedMonth);
    }

    /**
     * Test of getDay method, of class LocalDate.
     */
    @Test
    public void testGetDay() {
        //arrange
        int expectedDay = 6;
        int returnedDay;
        LocalDate localDate;
        //act
        localDate = new LocalDate(1994, 5, 6);
        returnedDay = localDate.getDay();
        //assert
        assertEquals(expectedDay, returnedDay);
    }

    /**
     * Test of toString method, of class LocalDate.
     */
    @Test
    public void testToString() { //arrange
        String expectedResult = "1994-05-06";
        String result;
        LocalDate localDate;
        //act
        localDate = new LocalDate(1994, 5, 6);
        result = localDate.toString();
        //assert
        assertEquals(expectedResult, result);
    }

}
