/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okay.datetime;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class LocalDateTimeTest {

    /**
     *
     */
    public LocalDateTimeTest() {
    }

    /**
     * Test of constructor of class LocalDateTime. (String dateTimeInString)
     */
    @Test
    public void testLocalDateTime_1argString_day6MustBeReturned() {
        //arrange
        LocalDateTime localDateTime;
        int expectedDay = 6;
        int returnedDay;
        //act
        localDateTime = new LocalDateTime("1994-05-06 21:45:06:032");
        returnedDay = localDateTime.getDay();
        //assert
        assertEquals(expectedDay, returnedDay);
    }

    /**
     * Test of constructor of class LocalDateTime. (int year, int month, int
     * day, int hour24Format, int minute, int second, int millisecond)
     */
    @Test
    public void testLocalDateTime_7args_day6MustBeReturned() {
        //arrange
        LocalDateTime localDateTime;
        int expectedDay = 6;
        int returnedDay;
        //act
        localDateTime = new LocalDateTime(1994, 5, 6, 21, 45, 6, 32);
        returnedDay = localDateTime.getDay();
        //assert
        assertEquals(expectedDay, returnedDay);
    }

    /**
     * Test of constructor of class LocalDateTime. (UniversalDateTime
     * universalDateTime)
     */
    @Test
    public void testLocalDateTime_1argUniversalDateTime_day6MustBeReturned() {
        //arrange
        LocalDateTime localDateTime;
        UniversalDateTime universalDateTime;
        int expectedDay = 6;
        int returnedDay;
        //act
        universalDateTime = new UniversalDateTime(1994, 5, 6, 21, 45, 6, 32);
        localDateTime = new LocalDateTime(universalDateTime);
        returnedDay = localDateTime.getDay();
        //assert
        assertEquals(expectedDay, returnedDay);
    }

    /**
     * Test of constructor of class LocalDateTime. (ZonedDateTime zonedDateTime)
     */
    @Test
    public void testLocalDateTime_1argZonedDateTime_day6MustBeReturned() {
        //arrange
        LocalDateTime localDateTime;
        TimeZone timeZone;
        ZonedDateTime zonedDateTime;
        int expectedDay = 6;
        int returnedDay;
        //act
        timeZone = new TimeZone("Australia/Sydney");
        zonedDateTime = new ZonedDateTime(new LocalDateTime(1994, 5, 6, 21, 45, 6, 32), timeZone);
        localDateTime = new LocalDateTime(zonedDateTime);
        returnedDay = localDateTime.getDay();
        //assert
        assertEquals(expectedDay, returnedDay);
    }

    /**
     * Test of toUniversalDateTime method, of class LocalDateTime.
     */
    @Test
    public void testToUniversalDateTime() {
        //arrange
        LocalDateTime localDateTime;
        UniversalDateTime universalDateTime;
        int expectedDay = 6;
        int returnedDay;
        //act
        localDateTime = new LocalDateTime(1994, 5, 6, 21, 45, 6, 32);
        universalDateTime = localDateTime.toUniversalDateTime();
        returnedDay = universalDateTime.getDay();
        //assert
        assertEquals(expectedDay, returnedDay);
    }

    /**
     * Test of toZonedDateTime method, of class LocalDateTime.
     */
    @Test
    public void testToZonedDateTime() {
        //arrange
        LocalDateTime localDateTime;
        TimeZone timeZone;
        ZonedDateTime zonedDateTime;
        int expectedDay = 6;
        int returnedDay;
        //act
        timeZone = new TimeZone("Australia/Sydney");
        localDateTime = new LocalDateTime(1994, 5, 6, 21, 45, 6, 32);
        zonedDateTime = localDateTime.toZonedDateTime(timeZone);
        returnedDay = zonedDateTime.getDay();
        //assert
        assertEquals(expectedDay, returnedDay);
    }

    /**
     * Test of toJavaLocalDateTime method, of class LocalDateTime.
     */
    @Test
    public void testToJavaLocalDateTime() {
        //arrange
        LocalDateTime localDateTime;
        java.time.LocalDateTime javaLocalDateTime;
        int expectedDay = 6;
        int returnedDay;
        //act
        localDateTime = new LocalDateTime(1994, 5, 6, 21, 45, 6, 32);
        javaLocalDateTime = localDateTime.toJavaLocalDateTime();
        returnedDay = javaLocalDateTime.getDayOfMonth();
        //assert
        assertEquals(expectedDay, returnedDay);
    }

}
